## serioussam-1.10.6d.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(SeriousEngine)

# Set @rpath for Mac OS X shared library install names.

# Use system SDL2 is on by default
option(USE_SYSTEM_SDL2 "Use systems sdl2 development files" On)
option(USE_SYSTEM_ZLIB "Use systems zlib development files" On)
option(USE_SYSTEM_VULKAN "Use systems vulkan development files" On)
option(USE_CCACHE "Set to ON to use ccache if present in the system" ${USE_CCACHE})
option(USE_SYSTEM_INSTALL "Install to systems directories" Off)

# fallback for cmake versions without add_compile_options # RAKE! Borrowed from dhewm3 project
if(NOT COMMAND add_compile_options)
	function(add_compile_options)
		foreach(arg ${ARGN})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${arg}" PARENT_SCOPE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${arg}" PARENT_SCOPE)
		endforeach()
	endfunction()
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
include(CheckCXXCompilerFlag)

# SeriousSam expects the libs to be in Debug/
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Debug)

if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif()
endif()


# Use systemwide SDL2 or custom build
# RAKE!: Find a way to use their custom built library if
# they want to use that instead or if their system only
# allows for a setup like this. Maybe use a SDL2_DIR var or
# some thing set in the system enviroment.
if(NOT USE_SYSTEM_SDL2)
    include_directories(${CMAKE_SOURCE_DIR}/External/SDL2)
else()
    find_package(SDL2 REQUIRED)
    if(SDL2_FOUND)
	include_directories(${SDL2_INCLUDE_DIR})
    else()
        message(FATAL_ERROR "Error USE_SYSTEM_SDL2 is set but neccessary developer files are missing")
    endif()
endif()

if(USE_SYSTEM_ZLIB)
    find_package(ZLIB REQUIRED)
    if(ZLIB_FOUND)
        include_directories(${ZLIB_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_ZLIB is set but neccessary developer files are missing")
    endif()
endif()

# NetBSD not support Vulkan. Build only OpenGL render.
if(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
     set(USE_SYSTEM_VULKAN FALSE)
     message(STATUS "NetBSD: Building OpenGL version only")
endif()

if(USE_SYSTEM_VULKAN)
    find_package(Vulkan REQUIRED)
    if(Vulkan_FOUND)
        include_directories(${Vulkan_INCLUDE_DIRS})
        message(STATUS "Building Vulkan/OpenGL version")
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_VULKAN is set but neccessary developer files are missing")
    endif()
else()
    message(STATUS "Building OpenGL version only without Vulkan support")
endif()


# Set up some sanity stuff...
if(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME MATCHES "GNU")
    set(LINUX TRUE)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" OR CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
    set(FREEBSD TRUE)
endif()
if(APPLE)
    set(MACOSX TRUE)
endif()
if(MSVC)
    set(WINDOWS TRUE)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
    include_directories("/usr/X11R6/include")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "None Debug Release RelWithDebInfo MinSizeRel" FORCE)
endif()
set(DEBUG FALSE)
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DEBUG TRUE)
endif()

if(LINUX)
    set(CMAKE_OS_NAME "GNU/Linux" CACHE STRING "Operating system name" FORCE)
    ## Check for Debian GNU/Linux
    find_file(DEBIAN_FOUND debian_version debconf.conf
        PATHS /etc
    )
    if(DEBIAN_FOUND)
        set(CMAKE_OS_NAME "Debian" CACHE STRING "Operating system name" FORCE)
    endif(DEBIAN_FOUND)
    ##  Check for Fedora
    find_file(FEDORA_FOUND fedora-release
        PATHS /etc
    )
    if(FEDORA_FOUND)
        set(CMAKE_OS_NAME "Fedora" CACHE STRING "Operating system name" FORCE)
    endif(FEDORA_FOUND)
    ##  Check for RedHat
    find_file(REDHAT_FOUND redhat-release inittab.RH
        PATHS /etc
    )
    if(REDHAT_FOUND)
        set(CMAKE_OS_NAME "RedHat" CACHE STRING "Operating system name" FORCE)
    endif(REDHAT_FOUND)
    ##  Check for Gentoo
    find_file(OS_Release_FOUND os-release
        PATHS /usr/lib
    )
    if (OS_Release_FOUND)
        ## Scan contents of file
        file(STRINGS ${OS_Release_FOUND} Gentoo_FOUND
            REGEX Gentoo
        )
        ## Check result of string search
        if(Gentoo_FOUND)
            set(CMAKE_OS_NAME "Gentoo" CACHE STRING "Operating system name" FORCE)
            set(DEBIAN_FOUND FALSE)
        endif(Gentoo_FOUND)
    endif(OS_Release_FOUND)
    ## Extra check for Ubuntu    
    if(DEBIAN_FOUND)
      ## At its core Ubuntu is a Debian system, with
      ## a slightly altered configuration; hence from
      ## a first superficial inspection a system will
      ## be considered as Debian, which signifies an
      ## extra check is required.
      find_file(UBUNTU_EXTRA legal issue
        PATHS /etc
      )
      if(UBUNTU_EXTRA)
        ## Scan contents of file
        file(STRINGS ${UBUNTU_EXTRA} UBUNTU_FOUND
          REGEX Ubuntu
        )
        ## Check result of string search
        if(UBUNTU_FOUND)
          set(CMAKE_OS_NAME "Ubuntu" CACHE STRING "Operating system name" FORCE)
          set(DEBIAN_FOUND FALSE)
        endif(UBUNTU_FOUND)
      endif(UBUNTU_EXTRA)      
    endif(DEBIAN_FOUND)
endif(LINUX)

add_subdirectory(SamTFE/Sources)
add_subdirectory(SamTSE/Sources)

=== SamTFE/Sources/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(SeriousEngine)

# set minimal standart
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Set @rpath for Mac OS X shared library install names.
#cmake_policy(SET CMP0042 NEW)

# Use system SDL2 is on by default
option(USE_SYSTEM_SDL2 "Use systems sdl2 development files" On)
option(USE_SYSTEM_ZLIB "Use systems zlib development files" On)
option(USE_SYSTEM_VULKAN "Use systems vulkan development files" On)
option(USE_CCACHE "Set to ON to use ccache if present in the system" ${USE_CCACHE})
option(USE_SYSTEM_INSTALL "Install to systems directories" Off)

# fallback for cmake versions without add_compile_options # RAKE! Borrowed from dhewm3 project
if(NOT COMMAND add_compile_options)
	function(add_compile_options)
		foreach(arg ${ARGN})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${arg}" PARENT_SCOPE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${arg}" PARENT_SCOPE)
		endforeach()
	endfunction()
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
include(CheckCXXCompilerFlag)

# SeriousSam expects the libs to be in Debug/
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Debug)

if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif()
endif()


# Use systemwide SDL2 or custom build
# RAKE!: Find a way to use their custom built library if
# they want to use that instead or if their system only
# allows for a setup like this. Maybe use a SDL2_DIR var or
# some thing set in the system enviroment.
if(NOT USE_SYSTEM_SDL2)
    include_directories(${CMAKE_SOURCE_DIR}/External/SDL2)
else()
    find_package(SDL2 REQUIRED)
    if(SDL2_FOUND)
	include_directories(${SDL2_INCLUDE_DIR})
    else()
        message(FATAL_ERROR "Error USE_SYSTEM_SDL2 is set but neccessary developer files are missing")
    endif()
endif()

if(USE_SYSTEM_ZLIB)
    find_package(ZLIB REQUIRED)
    if(ZLIB_FOUND)
        include_directories(${ZLIB_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_ZLIB is set but neccessary developer files are missing")
    endif()
else()
    add_definitions(-DSE1_ZLIB=1)
endif()

option(USE_ASM "Use ASM code" TRUE)
if (USE_ASM)
    MESSAGE(STATUS "Using assembler code (when available)")
else()
    add_definitions(-DUSE_PORTABLE_C=1)
    MESSAGE(STATUS "Using portable C instead of all ASM")
endif()

# NetBSD not support Vulkan. Build only OpenGL render.
if(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
     set(USE_SYSTEM_VULKAN FALSE)
endif()

if(USE_SYSTEM_VULKAN)
    find_package(Vulkan REQUIRED)
    if(Vulkan_FOUND)
        include_directories(${Vulkan_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_VULKAN is set but neccessary developer files are missing")
    endif()
endif()

###############################################################
##### Serious Sam Classic The First Encounter definitions #####
#####                                                     #####
###############################################################

set(INTERNAL_NAME "serioussam")

###############################################################
###############################################################
###############################################################

# Define Target install dir
string(FIND "${CMAKE_SOURCE_DIR}" "SamTFE/Sources" Found_SamTFE)
string(FIND "${CMAKE_SOURCE_DIR}" "SamTSE/Sources" Found_SamTSE)
if(("${Found_SamTFE}" EQUAL "-1") AND ("${Found_SamTSE}" EQUAL "-1"))
  set(Found_Sam "0")
else()
  set(Found_Sam "10")
endif()

if("${Found_Sam}" EQUAL "0")
  if(INTERNAL_NAME STREQUAL "serioussam")
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}/SamTFE/Sources")
  else()
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}/SamTSE/Sources")
  endif()
    message(STATUS "Using CMakeLists.txt from main directory")
else()
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}")
    message(STATUS "Using CMakeLists.txt from subdirectory")
endif()

option(TFE "Compile a The First Encounter version" FALSE)

if(INTERNAL_NAME STREQUAL "serioussam")
 add_definitions(-DFIRST_ENCOUNTER=1)
 if(USE_SYSTEM_VULKAN)
   add_definitions(-DSE1_VULKAN=1)
 endif()
 set(MP "")
 message(STATUS "Building Serious Sam Classic The First Encounter")
else()
 if(USE_SYSTEM_VULKAN)
   add_definitions(-DSE1_VULKAN=1)
 endif()
 set(MP "MP")
 message(STATUS "Building Serious Sam Classic The Second Encounter")
endif()

###############################################################
###############################################################
###############################################################

# Set up some sanity stuff...
# Note:
# "-rpath,$ORIGIN" allows you not to use LD_LIBRARY_PATH and is well suited for local installation
# "-rpath,$ORIGIN" don't like new versions of clang + ninja and crashes during linking of the Engine library
# "-rpath=/tmp" is suitable for linking clang + ninja and installing the game into the system
# "-rpath=/var/tmp/portage" is suitable for Gentoo and installing the game into the system
if(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME MATCHES "GNU")
    set(LINUX TRUE)
    message(STATUS "Set GNU Linux TRUE")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-reorder -Wno-unused-but-set-variable -Wno-maybe-uninitialized -Wno-class-memaccess -Wno-unused-function")
    if(CMAKE_OS_NAME STREQUAL "Gentoo" AND USE_SYSTEM_INSTALL)
      set(RPATH_SETTINGS "-rpath=/var/tmp/portage")
      message(STATUS "Build for Gentoo with '-rpath=/var/tmp/portage'")
    else()
      set(RPATH_SETTINGS "-rpath,$ORIGIN")
    endif()
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" OR CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nullability-completeness -Wno-unused-but-set-variable -Wno-uninitialized -Wno-unused-function")
    set(FREEBSD TRUE)
    if(CMAKE_GENERATOR STREQUAL "Unix Makefiles")                                  # for local instal
      if(CMAKE_SYSTEM_PROCESSOR MATCHES "i386|i686|x86|amd64|AMD64" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        if(USE_ASM)
          set(RPATH_SETTINGS "-z,notext,-rpath,$ORIGIN")
          message(STATUS "Arch i386 using -Wl,-z,notext LD flags")
        else()
          set(RPATH_SETTINGS "-rpath,$ORIGIN")
          message(STATUS "Arch i386 portable C instead of all ASM")
        endif()
      else()
        set(RPATH_SETTINGS "-rpath,$ORIGIN")
      endif()
      message(STATUS "Using cmake generator 'Unix Makefiles'")
    elseif(CMAKE_GENERATOR STREQUAL "Ninja")                                       # defalt for install to the system
      if(CMAKE_SYSTEM_PROCESSOR MATCHES "i386|i686|x86|amd64|AMD64" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        if(USE_ASM)
          set(RPATH_SETTINGS "-z,notext,-rpath=/tmp")
          message(STATUS "Arch i386 using -Wl,-z,notext LD flags")
        else()
          set(RPATH_SETTINGS "-rpath=/tmp")
          message(STATUS "Arch i386 portable C instead of all ASM")
        endif()
      else()
        set(RPATH_SETTINGS "-rpath=/tmp")
      endif()  
      message(STATUS "Using cmake generator 'Ninja'")
    else()
        message(FATAL_ERROR "Unknown cmake generator")
    endif()
endif()

if(APPLE)
    set(MACOSX TRUE)
    if(CMAKE_GENERATOR STREQUAL "Unix Makefiles")
      set(RPATH_SETTINGS "-rpath,$ORIGIN")
      message(STATUS "Using cmake generator 'Unix Makefiles'")
    elseif(CMAKE_GENERATOR STREQUAL "Ninja")
      set(RPATH_SETTINGS "-rpath=/tmp")     
      message(STATUS "Using cmake generator 'Ninja'")
    else()
        message(FATAL_ERROR "Unknown cmake generator")
    endif()
endif()

if(MSVC)
    set(WINDOWS TRUE)
endif()

# RAKE! Where to install the binaries.
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local" OR CMAKE_INSTALL_PREFIX STREQUAL "") # Only works for linux since I don't
                                                                                   # know what default is for windows/macos/freebsd.
    if("${Found_Sam}" EQUAL "0")
        if(INTERNAL_NAME STREQUAL "serioussam")
            set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/SamTFE/Sources/../")     # set install path to project root directory since
        else()                                                                     # since one wasn't set during config
            set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/SamTSE/Sources/../")     # set install path to project root directory since
        endif()                                                                    # since one wasn't set during config
    else()
        set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/../")                        # set install path to project root directory since
    endif()                                                                        # since one wasn't set during config
    if(NOT USE_SYSTEM_INSTALL)
        set(LOCAL_INSTALL TRUE)
        message(STATUS "Using LOCAL Install")
    endif() 
endif()
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR USE_SYSTEM_INSTALL)
    set(LOCAL_INSTALL FALSE)
    message(STATUS "Using SYSTEM Install")
    if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
        set(CMAKE_INSTALL_PREFIX "/usr/local")
    elseif(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
        set(CMAKE_INSTALL_PREFIX "/usr/pkg")
    else()
        set(CMAKE_INSTALL_PREFIX "/usr")  
    endif()
endif()

# ImageMagic needed for SYSTEM INSTALL
if(NOT LOCAL_INSTALL)
	find_package(ImageMagick COMPONENTS convert)
    if(ImageMagick_convert_FOUND)
        #message(STATUS "ImageMagick convert found: ${ImageMagick_convert_EXECUTABLE}")
    else()
        message(FATAL_ERROR "Error! LOCAL_INSTAL is set but neccessary ImageMagick convert are missing")
    endif()
endif()

# remove clang spam.
if(MACOSX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nullability-completeness -Wno-deprecated")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "None Debug Release RelWithDebInfo MinSizeRel" FORCE)
endif()
set(DEBUG FALSE)
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DEBUG TRUE)
endif()

if(LINUX)
    set(CMAKE_OS_NAME "GNU/Linux" CACHE STRING "Operating system name" FORCE)
    ## Check for Debian GNU/Linux
    find_file(DEBIAN_FOUND debian_version debconf.conf
        PATHS /etc
    )
    if(DEBIAN_FOUND)
        set(CMAKE_OS_NAME "Debian" CACHE STRING "Operating system name" FORCE)
    endif(DEBIAN_FOUND)
    ##  Check for Fedora
    find_file(FEDORA_FOUND fedora-release
        PATHS /etc
    )
    if(FEDORA_FOUND)
        set(CMAKE_OS_NAME "Fedora" CACHE STRING "Operating system name" FORCE)
    endif(FEDORA_FOUND)
    ##  Check for RedHat
    find_file(REDHAT_FOUND redhat-release inittab.RH
        PATHS /etc
    )
    if(REDHAT_FOUND)
        set(CMAKE_OS_NAME "RedHat" CACHE STRING "Operating system name" FORCE)
    endif(REDHAT_FOUND)
    ##  Check for Gentoo
    find_file(OS_Release_FOUND os-release
        PATHS /usr/lib
    )
    if (OS_Release_FOUND)
        ## Scan contents of file
        file(STRINGS ${OS_Release_FOUND} Gentoo_FOUND
            REGEX Gentoo
        )
        ## Check result of string search
        if(Gentoo_FOUND)
            set(CMAKE_OS_NAME "Gentoo" CACHE STRING "Operating system name" FORCE)
            set(DEBIAN_FOUND FALSE)
        endif(Gentoo_FOUND)
    endif(OS_Release_FOUND)
    ## Extra check for Ubuntu    
    if(DEBIAN_FOUND)
      ## At its core Ubuntu is a Debian system, with
      ## a slightly altered configuration; hence from
      ## a first superficial inspection a system will
      ## be considered as Debian, which signifies an
      ## extra check is required.
      find_file(UBUNTU_EXTRA legal issue
        PATHS /etc
      )
      if(UBUNTU_EXTRA)
        ## Scan contents of file
        file(STRINGS ${UBUNTU_EXTRA} UBUNTU_FOUND
          REGEX Ubuntu
        )

=== SamTSE/Sources/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(SeriousEngine)

# set minimal standart
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Set @rpath for Mac OS X shared library install names.
#cmake_policy(SET CMP0042 NEW)

# Use system SDL2 is on by default
option(USE_SYSTEM_SDL2 "Use systems sdl2 development files" On)
option(USE_SYSTEM_ZLIB "Use systems zlib development files" On)
option(USE_SYSTEM_VULKAN "Use systems vulkan development files" On)
option(USE_CCACHE "Set to ON to use ccache if present in the system" ${USE_CCACHE})
option(USE_SYSTEM_INSTALL "Install to systems directories" Off)

# fallback for cmake versions without add_compile_options # RAKE! Borrowed from dhewm3 project
if(NOT COMMAND add_compile_options)
	function(add_compile_options)
		foreach(arg ${ARGN})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${arg}" PARENT_SCOPE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${arg}" PARENT_SCOPE)
		endforeach()
	endfunction()
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
include(CheckCXXCompilerFlag)

# SeriousSam expects the libs to be in Debug/
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Debug)

if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif()
endif()


# Use systemwide SDL2 or custom build
# RAKE!: Find a way to use their custom built library if
# they want to use that instead or if their system only
# allows for a setup like this. Maybe use a SDL2_DIR var or
# some thing set in the system enviroment.
if(NOT USE_SYSTEM_SDL2)
    include_directories(${CMAKE_SOURCE_DIR}/External/SDL2)
else()
    find_package(SDL2 REQUIRED)
    if(SDL2_FOUND)
	include_directories(${SDL2_INCLUDE_DIR})
    else()
        message(FATAL_ERROR "Error USE_SYSTEM_SDL2 is set but neccessary developer files are missing")
    endif()
endif()

if(USE_SYSTEM_ZLIB)
    find_package(ZLIB REQUIRED)
    if(ZLIB_FOUND)
        include_directories(${ZLIB_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_ZLIB is set but neccessary developer files are missing")
    endif()
else()
    add_definitions(-DSE1_ZLIB=1)
endif()

option(USE_ASM "Use ASM code" TRUE)
if (USE_ASM)
    MESSAGE(STATUS "Using assembler code (when available)")
else()
    add_definitions(-DUSE_PORTABLE_C=1)
    MESSAGE(STATUS "Using portable C instead of all ASM")
endif()

# NetBSD not support Vulkan. Build only OpenGL render.
if(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
     set(USE_SYSTEM_VULKAN FALSE)
endif()

if(USE_SYSTEM_VULKAN)
    find_package(Vulkan REQUIRED)
    if(Vulkan_FOUND)
        include_directories(${Vulkan_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Error! USE_SYSTEM_VULKAN is set but neccessary developer files are missing")
    endif()
endif()

################################################################
##### Serious Sam Classic The Second Encounter definitions #####
#####                                                      #####
################################################################

set(INTERNAL_NAME "serioussamse")

###############################################################
###############################################################
###############################################################

# Define Target install dir
string(FIND "${CMAKE_SOURCE_DIR}" "SamTFE/Sources" Found_SamTFE)
string(FIND "${CMAKE_SOURCE_DIR}" "SamTSE/Sources" Found_SamTSE)
if(("${Found_SamTFE}" EQUAL "-1") AND ("${Found_SamTSE}" EQUAL "-1"))
  set(Found_Sam "0")
else()
  set(Found_Sam "10")
endif()

if("${Found_Sam}" EQUAL "0")
  if(INTERNAL_NAME STREQUAL "serioussam")
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}/SamTFE/Sources")
  else()
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}/SamTSE/Sources")
  endif()
    message(STATUS "Using CMakeLists.txt from main directory")
else()
    set(CMAKE_ADD_TARGET_DIR "${CMAKE_SOURCE_DIR}")
    message(STATUS "Using CMakeLists.txt from subdirectory")
endif()

option(TFE "Compile a The First Encounter version" FALSE)

if(INTERNAL_NAME STREQUAL "serioussam")
 add_definitions(-DFIRST_ENCOUNTER=1)
 if(USE_SYSTEM_VULKAN)
   add_definitions(-DSE1_VULKAN=1)
 endif()
 set(MP "")
 message(STATUS "Building Serious Sam Classic The First Encounter")
else()
 if(USE_SYSTEM_VULKAN)
   add_definitions(-DSE1_VULKAN=1)
 endif()
 set(MP "MP")
 message(STATUS "Building Serious Sam Classic The Second Encounter")
endif()

###############################################################
###############################################################
###############################################################

# Set up some sanity stuff...
# Note:
# "-rpath,$ORIGIN" allows you not to use LD_LIBRARY_PATH and is well suited for local installation
# "-rpath,$ORIGIN" don't like new versions of clang + ninja and crashes during linking of the Engine library
# "-rpath=/tmp" is suitable for linking clang + ninja and installing the game into the system
# "-rpath=/var/tmp/portage" is suitable for Gentoo and installing the game into the system
if(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME MATCHES "GNU")
    set(LINUX TRUE)
    message(STATUS "Set GNU Linux TRUE")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-reorder -Wno-unused-but-set-variable -Wno-maybe-uninitialized -Wno-class-memaccess -Wno-unused-function")
    if(CMAKE_OS_NAME STREQUAL "Gentoo" AND USE_SYSTEM_INSTALL)
      set(RPATH_SETTINGS "-rpath=/var/tmp/portage")
      message(STATUS "Build for Gentoo with '-rpath=/var/tmp/portage'")
    else()
      set(RPATH_SETTINGS "-rpath,$ORIGIN")
    endif()
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" OR CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nullability-completeness -Wno-unused-but-set-variable -Wno-uninitialized -Wno-unused-function")
    set(FREEBSD TRUE)
    if(CMAKE_GENERATOR STREQUAL "Unix Makefiles")                                  # for local instal
      if(CMAKE_SYSTEM_PROCESSOR MATCHES "i386|i686|x86|amd64|AMD64" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        if(USE_ASM)
          set(RPATH_SETTINGS "-z,notext,-rpath,$ORIGIN")
          message(STATUS "Arch i386 using -Wl,-z,notext LD flags")
        else()
          set(RPATH_SETTINGS "-rpath,$ORIGIN")
          message(STATUS "Arch i386 portable C instead of all ASM")
        endif()
      else()
        set(RPATH_SETTINGS "-rpath,$ORIGIN")
      endif()
      message(STATUS "Using cmake generator 'Unix Makefiles'")
    elseif(CMAKE_GENERATOR STREQUAL "Ninja")                                       # defalt for install to the system
      if(CMAKE_SYSTEM_PROCESSOR MATCHES "i386|i686|x86|amd64|AMD64" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        if(USE_ASM)
          set(RPATH_SETTINGS "-z,notext,-rpath=/tmp")
          message(STATUS "Arch i386 using -Wl,-z,notext LD flags")
        else()
          set(RPATH_SETTINGS "-rpath=/tmp")
          message(STATUS "Arch i386 portable C instead of all ASM")
        endif()
      else()
        set(RPATH_SETTINGS "-rpath=/tmp")
      endif()  
      message(STATUS "Using cmake generator 'Ninja'")
    else()
        message(FATAL_ERROR "Unknown cmake generator")
    endif()
endif()

if(APPLE)
    set(MACOSX TRUE)
    if(CMAKE_GENERATOR STREQUAL "Unix Makefiles")
      set(RPATH_SETTINGS "-rpath,$ORIGIN")
      message(STATUS "Using cmake generator 'Unix Makefiles'")
    elseif(CMAKE_GENERATOR STREQUAL "Ninja")
      set(RPATH_SETTINGS "-rpath=/tmp")     
      message(STATUS "Using cmake generator 'Ninja'")
    else()
        message(FATAL_ERROR "Unknown cmake generator")
    endif()
endif()

if(MSVC)
    set(WINDOWS TRUE)
endif()

# RAKE! Where to install the binaries.
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local" OR CMAKE_INSTALL_PREFIX STREQUAL "") # Only works for linux since I don't
                                                                                   # know what default is for windows/macos/freebsd.
    if("${Found_Sam}" EQUAL "0")
        if(INTERNAL_NAME STREQUAL "serioussam")
            set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/SamTFE/Sources/../")     # set install path to project root directory since
        else()                                                                     # since one wasn't set during config
            set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/SamTSE/Sources/../")     # set install path to project root directory since
        endif()                                                                    # since one wasn't set during config
    else()
        set(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/../")                        # set install path to project root directory since
    endif()                                                                        # since one wasn't set during config
    if(NOT USE_SYSTEM_INSTALL)
        set(LOCAL_INSTALL TRUE)
        message(STATUS "Using LOCAL Install")
    endif() 
endif()
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR USE_SYSTEM_INSTALL)
    set(LOCAL_INSTALL FALSE)
    message(STATUS "Using SYSTEM Install")
    if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
        set(CMAKE_INSTALL_PREFIX "/usr/local")
    elseif(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
        set(CMAKE_INSTALL_PREFIX "/usr/pkg")
    else()
        set(CMAKE_INSTALL_PREFIX "/usr")  
    endif()
endif()

# ImageMagic needed for SYSTEM INSTALL
if(NOT LOCAL_INSTALL)
	find_package(ImageMagick COMPONENTS convert)
    if(ImageMagick_convert_FOUND)
        #message(STATUS "ImageMagick convert found: ${ImageMagick_convert_EXECUTABLE}")
    else()
        message(FATAL_ERROR "Error! LOCAL_INSTAL is set but neccessary ImageMagick convert are missing")
    endif()
endif()

# remove clang spam.
if(MACOSX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nullability-completeness -Wno-deprecated")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "None Debug Release RelWithDebInfo MinSizeRel" FORCE)
endif()
set(DEBUG FALSE)
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DEBUG TRUE)
endif()

if(LINUX)
    set(CMAKE_OS_NAME "GNU/Linux" CACHE STRING "Operating system name" FORCE)
    ## Check for Debian GNU/Linux
    find_file(DEBIAN_FOUND debian_version debconf.conf
        PATHS /etc
    )
    if(DEBIAN_FOUND)
        set(CMAKE_OS_NAME "Debian" CACHE STRING "Operating system name" FORCE)
    endif(DEBIAN_FOUND)
    ##  Check for Fedora
    find_file(FEDORA_FOUND fedora-release
        PATHS /etc
    )
    if(FEDORA_FOUND)
        set(CMAKE_OS_NAME "Fedora" CACHE STRING "Operating system name" FORCE)
    endif(FEDORA_FOUND)
    ##  Check for RedHat
    find_file(REDHAT_FOUND redhat-release inittab.RH
        PATHS /etc
    )
    if(REDHAT_FOUND)
        set(CMAKE_OS_NAME "RedHat" CACHE STRING "Operating system name" FORCE)
    endif(REDHAT_FOUND)
    ##  Check for Gentoo
    find_file(OS_Release_FOUND os-release
        PATHS /usr/lib
    )
    if (OS_Release_FOUND)
        ## Scan contents of file
        file(STRINGS ${OS_Release_FOUND} Gentoo_FOUND
            REGEX Gentoo
        )
        ## Check result of string search
        if(Gentoo_FOUND)
            set(CMAKE_OS_NAME "Gentoo" CACHE STRING "Operating system name" FORCE)
            set(DEBIAN_FOUND FALSE)
        endif(Gentoo_FOUND)
    endif(OS_Release_FOUND)
    ## Extra check for Ubuntu    
    if(DEBIAN_FOUND)
      ## At its core Ubuntu is a Debian system, with
      ## a slightly altered configuration; hence from
      ## a first superficial inspection a system will
      ## be considered as Debian, which signifies an
      ## extra check is required.
      find_file(UBUNTU_EXTRA legal issue
        PATHS /etc
      )
      if(UBUNTU_EXTRA)
        ## Scan contents of file
        file(STRINGS ${UBUNTU_EXTRA} UBUNTU_FOUND
          REGEX Ubuntu
        )

=== SamTFE/Sources/amp11lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(amp11lib)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffast-math -Wall")

add_definitions(-DFASTBITS)
add_definitions(-DTIME)
add_definitions(-DUNIX)
add_definitions(-DLINUX)
add_definitions(-DOSS)
add_definitions(-DAMP11LIB_EXPORTS)

set(SOURCE_FILES
    binfile/binfarc.cpp
    binfile/binfarc.h
    binfile/binfile.cpp
    binfile/binfile.h
    binfile/binfstd.cpp
    binfile/binfstd.h
    binfile/ptypes.h
    amp11lib.cpp
    amp11lib.h
    amp1dec.cpp
    amp2dec.cpp
    amp3dec.cpp
    ampdec.cpp
    ampdec.h
    ampsynth.cpp)

add_library(amp11lib SHARED ${SOURCE_FILES})

=== templates/freebsd/ports/games/serioussam-vk/Makefile ===
PORTNAME=	serioussam-vk
DISTNAME=	SeriousSamClassic-VK
DISTVERSION=	1.10.6c
PORTREVISION=	1
CATEGORIES=	games

MAINTAINER= 	YOUR@MAIL
COMMENT=	Serious Sam Classic is open source game engine with vulkan support
WWW=		https://github.com/tx00100xt/SeriousSamClassic-VK

LICENSE= 	GPLv2
LICENSE_FILE= 	${WRKSRC}/LICENSE

# The source code also contains definitions for
# architectures riscv64 s390x powerpc64le.
# Building code for them workd.
# Work on real hardware has been 
# tested for architectures: armv7 aaarch64 under Linux
ONLY_FOR_ARCHS= amd64 i386

BUILD_DEPENDS=	flex:textproc/flex \
		vulkan-headers>0:graphics/vulkan-headers \
		convert:graphics/ImageMagick7

# Libraries loaded with dlopen(3)
LIB_DEPENDS=	libogg.so:audio/libogg \
		libvorbis.so:audio/libvorbis \
		libvorbisfile.so:audio/libvorbis \
		libvulkan.so:graphics/vulkan-loader

USES=		bison:build cmake compiler:c++11-lang sdl desktop-file-utils
USE_CXXSTD=	c++14
USE_SDL=	sdl2

CONFLICTS=	serioussam

GH_ACCOUNT=	tx00100xt
GH_PROJECT=	SeriousSamClassic-VK
USE_GITHUB=	yes

CMAKE_ARGS=	-DRPI4:BOOL=FALSE -DUSE_ASM:BOOL=FALSE \
	-DUSE_SYSTEM_INSTALL:BOOL=TRUE -DUSE_I386_NASM_ASM:BOOL=FALSE

post-install:
	${INSTALL_MAN} ${WRKSRC}/man/bsd/serioussam-vk.1 ${STAGEDIR}${PREFIX}/man/man1/serioussam-vk.1
	${INSTALL_MAN} ${WRKSRC}/man/bsd/serioussamclassic-vk.1 ${STAGEDIR}${PREFIX}/man/man1/serioussamclassic-vk.1

.include <bsd.port.options.mk>

.if ${ARCH} == amd64
CMAKE_ON=	USE_ASM
.endif

# Unocmment this for aarch64 and armv7 architectures
#.if ${ARCH} == aarch64 || ${ARCH} == armv7
#CMAKE_ON=	RPI4
#.endif

.include	<bsd.port.mk>

=== templates/openbsd/ports/games/serioussam-vk/Makefile ===
COMMENT =	open source version of the classic Serious Sam game

V=		1.10.6c

DIST_TUPLE =	github tx00100xt SeriousSamClassic-VK ${V} .
PKGNAME =	serioussam-vk-${V}

CATEGORIES =	games

SHARED_LIBS +=	Engine 0.0
SHARED_LIBS +=	EngineMP 0.0

MAINTAINER =	Alexander Pavlov <t.x00100x.t@yandex.ru>

# GPLv2
PERMIT_PACKAGE =	Yes

# Extra: ogg.6 vorbis.9 vorbisfile.6 (dlopen)
WANTLIB =  ${COMPILER_LIBCXX} SDL2 c m ogg pthread vorbis vorbisfile z vulkan

MODULES =	devel/cmake

# c++14
COMPILER =	base-clang ports-gcc

CONFIGURE_ARGS +=	-DUSE_SYSTEM_INSTALL=ON

BUILD_DEPENDS =	audio/libogg \
		audio/libvorbis \
		devel/bison \
		devel/sdl2 \
		graphics/ImageMagick

# Libraries loaded with dlopen(3)
LIB_DEPENDS =	audio/libogg \
		audio/libvorbis \
		devel/sdl2 \
		graphics/vulkan-loader

RUN_DEPENDS =	devel/desktop-file-utils \
		x11/gtk+4,-guic

NO_TEST =	Yes

.if ${MACHINE_ARCH} == aarch64 || ${MACHINE_ARCH} == armv7
CONFIGURE_ARGS +=	-DRPI4=ON
.endif

.if ${MACHINE_ARCH}== i386 || ${MACHINE_ARCH}== amd64
CONFIGURE_ARGS +=	-DUSE_ASM=OFF
.endif

post-install:
	${INSTALL_MAN} ${WRKSRC}/man/bsd/serioussam-vk.1 \
		${PREFIX}/man/man1/serioussam-vk.1
	${INSTALL_MAN} ${WRKSRC}/man/bsd/serioussamclassic-vk.1 \
		${PREFIX}/man/man1/serioussamclassic-vk.1

.include <bsd.port.mk>

=== debian/changelog ===
serioussamclassic-vk (1.10.6-1) jammy; urgency=medium

  * Initial release

 -- YOUR_NAME <YOUR_EMAIL>  Tue, 16 Oct 2023 23:37:15 +0300

=== debian/control ===
Source: serioussamclassic-vk
Section: games
Priority: optional
Maintainer: YOUR_NAME <YOUR_EMAIL>
Build-Depends: debhelper-compat (= 13), cmake, flex, bison, nasm, libsdl2-dev, libvorbis-dev, zlib1g-dev, imagemagick, libvulkan-dev, vulkan-validationlayers-dev 
Standards-Version: 4.6.0
Homepage: https://github.com/tx00100xt/SeriousSamClassic-VK
Vcs-Browser: https://salsa.debian.org/debian/serioussamclassic-vk
Vcs-Git: https://salsa.debian.org/debian/serioussamclassic-vk.git
Rules-Requires-Root: no

Package: serioussamclassic-vk
Architecture: any
Conflicts: serioussam, serioussamse, serioussam-vk, serioussamse-vk, serioussamclassic
Depends: ${shlibs:Depends}, ${misc:Depends}, libc6 (>= 2.28), libsdl2-2.0-0 (>= 2.0.6), libstdc++6 (>= 5), zlib1g (>= 1:1.1.4), libvorbisfile3, libvulkan1 
Description: Linux port of Serious Sam Classic with Vulkan support
 Open source game engine version developed by Croteam 
 for Serious Sam Classic with Vulkan support (Windows, Linux, FreeBSD, Raspberry Pi OS)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_ADDTIONAL_FLAGS ?=
ifneq ($(DEB_HOST_ARCH_CPU),amd64)
CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS_SSE=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	find . -name "CMakeLists.txt" -exec sed -i 's/-march=native) # set mtune=generic/-mtune=generic) # set mtune=generic/g' {} +
	dh_auto_configure -- -G "Unix Makefiles" \
	 -DCMAKE_BUILD_TYPE=Release -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	 $(CMAKE_ADDITIONAL_FLAGS)

override_dh_installchangelogs:
	# We won't have a ChangeLog if packaging from a released tarball.
	# In this case, use the CHANGELOG.md
	dh_installchangelogs
	if [ ! -e ChangeLog ]; then \
	dh_installchangelogs -k CHANGELOG.md ; \
	fi
